
/* INTERF.C							*/
/* Arhivo de manejo de la interfase				*/
 
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "definic.h"
#include "interf.h"
#include "os_dep.h"
/*** VTP. Se sacaron las funciones no portables, escriba_dir y nombre_autor
	  ahora estan en osdep.h ***/

/* A este codigo fuente se le han aplicado estas tecnicas preventivas:*/
/* 1. assert al comienzo de toda funcion para verificar precondiciones */
/* 2. HayMem despues de cada malloc para verificar que se asigne memoria
      y para inicializar cada zona de memoria reservada en 0 */
/* 3. Los apuntadores liberados han sido dejados apuntando a NULL */
/* 4. Todo apuntador local a funciones no inicializado ha sido inicializado
      en NULL */
/* 5. Despues de cada fopen se agrego la funcion FileOpen */
/* v-tamara 7/May/1997 */


int total_mensajes=0;
char CadErrorAssert[200];

/**************************************************************************
* void iniciar_menus(void)                                                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO: Carga todos los menus que se usan en el sistema.             *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Hernan Aponte                                   FECHA: 28-ene-94 *
**************************************************************************/

void iniciar_menus(void)
{/*----------------------------------------------------------------------*/
	 FILE   *fp;
	 texpr  archivo;
	 texpr  linea;
	 int    num_op;
	 char   nombre_op[CAD],titulo[CAD];
	 opcion op;
	 int    i;
	 int    num_menus;

	 sprintf(archivo,"%s/%s",direct[0],direct[10]);
	 fp = fopen(archivo,"r");
	 if (fp == NULL) {
		  escriba_cadena("No pudo inicializar menus",2);
		  return;
	 }
	 num_menus = 0;
	 fgets(linea,sizeof(texpr),fp);
	 while (!feof(fp)) {
		  fscanf(fp,"%5d\n",&num_op);            /* lee el numero de opcs. */
		  menus_manta[num_menus] = crear_menu();
		  fgets(linea,sizeof(texpr),fp);         /* lee el titulo del menu */
		  formatear_linea(linea,titulo);
		  strcpy(menus_manta[num_menus]->titulo,titulo);
		  fgets(linea,sizeof(texpr),fp);         /* linea superflua */
		  for (i=0;i!=num_op;i++) {             /* lee las opciones */
				fgets(linea,sizeof(texpr),fp);
				formatear_linea(linea,nombre_op);
				op = crear_opcion(nombre_op);
				adic_opcion(menus_manta[num_menus],op);
		  }
		  num_menus++;
        fgets(linea,sizeof(texpr),fp);
    }
/*--------------------------------------------------------------------*/}

/************************************************************************
* int admon_menu(ptr_menu m)                                            *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:  m = un menu                                                     *
* POST: admon_menu = opcion escogida por el usuario del menu m          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 17/Jan/92                                            *
************************************************************************/

int admon_menu(ptr_menu m)
{/*--------------------------------------------------------------------*/
	int   op;
	texpr comando;
	assert(m!=NULL); /* VTP. 23/Abr/1997 */

	 pintar_menu(m);
	 if (flag_emacs)
		lea_cadena(comando);
	 else
		lea_nombre(mensajes[105],comando);
	 op = opcion_valida(m,comando);
	 if (op >= 0)
		m->act_op = op;
	 return(op);
/*--------------------------------------------------------------------*/}


/************************************************************************
* void admon_menu_scroll(ptr_menu m, nodo_nombre *lis, texpr comando,   *
*                        texpr mensaje)                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:  m = un menu, lis = tiene la lista de opciones del menu.         *
*       num_mensaje tiene el numero del mensaje que corresponde al      *
*       titulo del menu.                                                *
* POST: comando = nombre de la opcion escogida. Si no hubo eleccion     *
*       comando = "".                                                   *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 17/Jan/92                                            *
************************************************************************/

void admon_menu_scroll(ptr_menu m, nodo_nombre *lis, texpr comando)
{/*--------------------------------------------------------------------*/
	 int         op;
	 opcion      op_salir;
	 assert(m!=NULL && comando!=NULL);/* VTP. 23/Abr/1997 */
	 if (lis==NULL) {
		printf("_________________________________________________"
				 "____________________\n");
		printf("\n-----------------------------------------------"
				 "----------------------\n\n");
		return;
	 }
	 llenar_menu(m,lis);
	 op_salir = crear_opcion(mensajes[150]);
	 op_salir->longitud = CAD-1;
	 adic_opcion(m,op_salir);
/*    strcpy(m->titulo,mensaje);*/
	 pintar_menu(m);
/*    op = m->act_op;*/
	 strcpy(comando,"");
	 if (flag_emacs)
		lea_cadena(comando);
	 else
		lea_nombre(mensajes[105],comando); /* 105:Opcion */
	 op = opcion_valida(m,comando);
	 if (op == NO_OPCION)
		strcpy(comando,"");
	 else if (op < m->num_op)
		strcpy(comando,m->opciones[op]->nombre);
	 borrar_menu(m);
/*--------------------------------------------------------------------*/}


/************************************************************************
* void adic_opcion(ptr_menu m, opcion o)                                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE: m = un menu, o = una opcion, num_op = un numero de opcion        *
* POST: el menu m tiene la opcion o, todos sus campos se actualizan.    *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 17/Jan/92                                            *
************************************************************************/

void adic_opcion(ptr_menu m, opcion o)
{/*--------------------------------------------------------------------*/
	opcion *op;
	assert(m!=NULL && o!=NULL); /* VTP. 23/Abr/1997 */

	op=(opcion *)realloc(m->opciones,sizeof(opcion)*(m->num_op+1));
	if (op==NULL)
	  { escriba_mensaje(166); }
	else
	  {
	    m->opciones=op;
	    m->opciones[(m->num_op)++] = o;
	  }
/*--------------------------------------------------------------------*/}

/************************************************************************
* void borrar_menu(ptr_menu m)                                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:  m = un menu                                                     *
* POST: Se han borrado las opciones del menu m                          *
************************************************************************/

void borrar_menu(ptr_menu m)
{/*--------------------------------------------------------------------*/
	 int         num_op;

	 assert(m!=NULL); /* VTP. 30/Abr/1997 */
	 /* VTP. 30/Abr/1997 Cambie el orden, antes hacia m->num_op=0 aqui */
	 for (num_op = 0 ; num_op < m->num_op; num_op++)  {
		  free(m->opciones[num_op]);
 		  m->opciones[num_op]=NULL;                              
	 }
	 free(m->opciones);
	 m->opciones=NULL;
	 m->num_op = 0;
	 m->act_op = 0;

/*--------------------------------------------------------------------*/}


/************************************************************************
* opcion  crear_opcion(char nombre[])                                   *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE: True                                                             *
* POST: crear_opcion es una nueva opcion con nombre <nombre>            *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 17/Jan/92                                            *
************************************************************************/

opcion  crear_opcion(char nombre[])
{/*--------------------------------------------------------------------*/
	 opcion op;
	 op = (opcion)malloc(sizeof(struct sopcion));
	 HayMem(op,sizeof(struct sopcion));
	 strcpy(op->nombre,nombre);
	 op->longitud = strlen(nombre)+2;
	 return(op);
/*--------------------------------------------------------------------*/}
 
/************************************************************************
* ptr_menu  crear_menu()                                                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE: True                                                             *
* POST: crear_menu es un nuevo menu                                     *
*                                                                       *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 17/Jan/92                                            *
************************************************************************/
 
ptr_menu  crear_menu()
{/*--------------------------------------------------------------------*/
  ptr_menu m;

  m = (ptr_menu) malloc (sizeof(struct sptr_menu));
  HayMem(m,sizeof(struct sptr_menu)); /* VTP. 30/Abr/1997 */
  m->num_op = 0;
  strcpy(m->titulo,"");
  m->act_op = 0;
  m->opciones=NULL;
  return(m);
/*--------------------------------------------------------------------*/}

/**************************************************************************
* void desp_presentacion()                                                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO: Mostrar en la pantalla la bienvenida a ManTa                 *
**************************************************************************/

void  desp_presentacion()
{/*----------------------------------------------------------------------*/
  printf("\n\n\n\n");
  if (strncmp(direct[21],"espanol",7)==0)
    {
        printf(
        "       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
          printf(
        "\n                      Bienvenido a ManTa %s\n\n",VersionKernelManta);
          printf(
        "      M A N I P U L A D O R   D E   T I P O S   A B S T R A C T O S\n\n");
          printf(
        "                        UNIVERSIDAD DE LOS ANDES\n");
          printf(
        "                   GRUPO DE CONSTRUCCION DE SOFTWARE\n\n");
          printf(
        "                               1985 - 1999      \n\n");
          printf(
        "       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
    }
  else
    {
        printf(
        "       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
          printf(
        "\n                    Welcome to ManTa %s\n\n",VersionKernelManta);
          printf(
        "          A B S T R A C T   D A T A   T Y P E   H A N D L E R\n\n");
          printf(
        "                       UNIVERSIDAD DE LOS ANDES\n");
          printf(
        "                     SOFTWARE CONSTRUCTION GROUP\n\n");
          printf(
        "                              1985 - 1999      \n\n");
          printf(
        "       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
    }
          printf("\n\n\n\n"); 

/*----------------------------------------------------------------------*/}


/**************************************************************************
* void escriba_cadena(cad50 cadena, int n)                                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO: presentar en pantalla el string que viene en <cadena> y      *
*            salta <n> lineas.                                            *
*                                                                         *
**************************************************************************/

void  escriba_cadena(texpr cadena,int n)
{/*----------------------------------------------------------------------*/
	 int i;

	 assert(cadena!=NULL && n>=0 && strlen(cadena)<=sizeof(texpr)); /* VTP. 23/Abr/1997 */

	 printf("%s ", cadena);
	 for(i=n;i>0;i--)
		printf("\n");
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void escriba_dir(cad20 dir, cad20 ext)                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO: Desplegar en pantalla el contenido los archivos del          *
*            directorio dir, cuya extension sea ext.                      *
*                                                                         *
**************************************************************************/

void  escriba_dir( cad20 dir, cad20 ext)
{/*----------------------------------------------------------------------*/

	 nodo_nombre *l;
	 texpr       comando;
	 int         longitud;

	 assert(dir!=NULL && ext!=NULL && strlen(dir)<20 && strlen(ext)<20);
	  /* VTP. 23/Abr/1997 */

	 if (flag_emacs) {
		enviar_dir(dir,ext);
		return;
	 }

	 longitud=0;
	 sprintf(comando," %s/*.%s ",dir,ext);
	 transArch(comando); /* VTP. 15/Feb/1997 */
	 escriba_cadena(comando,1);
	 for (l=lista_dir(dir,ext,0); l != NULL; l = l->sig)
		if ((l->sig == NULL) || (longitud > 50)) {
	escriba_cadena(l->nombre,1);
	longitud=0;
		}
		else {
	escriba_cadena(l->nombre,0);
	longitud = longitud + strlen(l->nombre) + 1;
		}
	 escriba_cadena("",1);
	 liberar_nombres(&l);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void escriba_mensaje(int num_mensaje)	                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Escribe un mensaje en pantalla                             *
*                                                                         *
**************************************************************************/

void escriba_mensaje(int num_mensaje)
{/*----------------------------------------------------------------------*/

	assert(num_mensaje>=0 && num_mensaje<total_mensajes); /* VTP. 23/Abr/1997 */
  if (flag_emacs)
	 enviar_mensaje(num_mensaje);
  else
	 if (strchr(mensajes[num_mensaje],'?') != NULL)       /* es pregunta */
		escriba_cadena(mensajes[num_mensaje],0);
	 else
		escriba_cadena(mensajes[num_mensaje],1);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void escriba_mensaje_dinam(int num_mensaje)	                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Escribe un mensaje dinamico (creado en ejecucion) en la    *
*              pantalla                                                   *
*                                                                         *
**************************************************************************/

void escriba_mensaje_dinam(texpr mensaje)
{/*----------------------------------------------------------------------*/

	assert(mensaje!=NULL && strlen(mensaje)<MAX_TEXPR); /* VTP. 23/Abr/1997 */

  if (flag_emacs)
	 enviar_mensaje_dinamico(mensaje);
  else
	 if (strchr(mensaje,'?') != NULL)       /* es pregunta */
		escriba_cadena(mensaje,0);
	 else
		escriba_cadena(mensaje,1);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* short es_prefijo(cad20 comando,cad50 cad_opcion)  			  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Verificar si <comando> es prefijo de <cad_opcion>.         *
* PARAMETROS: cad20  comando                                              *
*             cad50  cad_opcion                                           *
* RESULTADO:  short  1, si <comando> es prefijo de <cad_op>. 0, sino.     *
* PRE!:  { comando = "a1 .. ak" , cad_opcion = "b1 .. bn" }.              *
* POST!: { es_prefijo = 1, si a1 = b1, ... ,ak = bk. 0, sino }.           *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 25-Ene-90 *
**************************************************************************/

short es_prefijo(cad20 comando,cad50 cad_opcion)
{/*----------------------------------------------------------------------*/
  int i;

  assert(comando!=NULL && strlen(comando)<=50);
  assert(cad_opcion!=NULL && strlen(cad_opcion)<=50); /* VTP. 23/Abr/1997 */

	 for (i=0; (comando[i] != '\0') && (cad_opcion[i] != 0) &&
				  (tolower(comando[i]) == tolower(cad_opcion[i])) ; i++)
	 ;
	 if (comando[i] == '\0')
		return(1);
	 else
		return(0)
	 ;
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void formatear_linea(texpr lin1, texpr lin2)                            *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Quitar los puntos del principio y fin de la linea lin1,    *
*              y dejar la respuesta en lin2.                              *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void formatear_linea(texpr lin1, texpr lin2)
{/*----------------------------------------------------------------------*/
	 int prim,ult; /* Primer y ultimo caracter imprimible de lin */
	 int j;

	 assert(lin1!=NULL && lin2!=NULL && strlen(lin1)<MAX_TEXPR
			  && strlen(lin2)<MAX_TEXPR); /* VTP. 23/Abr/1997 */

	 for (prim=0,ult = strlen(lin1);(prim < ult) && (lin1[prim] != '.');prim++);
	 for (;(ult > prim) && (lin1[ult] != '.');ult--);
	 for (j=0,prim++;prim < ult; j++,prim++) {
		  if (lin1[prim] == '\\') {
				switch (lin1[++prim]) {
					 case 'n' :
						  lin2[j] = '\n';
						  break;
					 case 't' :
						  lin2[j] = '\t';
						  break;
					 default :
						  lin2[j] = lin1[prim];
						  break;
				}
		  }
		  else
				lin2[j] = lin1[prim];
	 }
	 lin2[j]='\0';
 /*----------------------------------------------------------------------*/}

/**************************************************************************
* void iniciar_mensajes(void)                                             *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Iniciar el arreglo de mensajes con el contenido del        *
*              archivo de mensajes.                                       *
* PRE!:  { Nombre es un archivo de mesajes con este formato :             *
*    nnnn   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx                        *
*   Donde nnnn es el numero del mensaje y xxxxxxx es el mensaje           *
*    or  nombre es espacio or nombre no corresponde a ningun archivo      *
* POST!: { Si nombre es correcto carga el archivo de mensajes, si es      *
*          vacio o incorrecto, carga el archivo mesages.msg               *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void iniciar_mensajes(void)
{/*----------------------------------------------------------------------*/

	 FILE   *fp;
	 texpr  archivo;
	 texpr  linea;
	 int    i,fin;

	 for (i=0;i<MAX_MENSAJES;i++)
		  strcpy(mensajes[i],"\0");
	 sprintf(archivo,"%s/%s",direct[0],direct[11]);
	 fp = fopen(archivo,"r");
	 if (fp == NULL)           {
	   sprintf(linea,"Can't open messages file: %s\n",archivo);
	   escriba_cadena(linea,1);
	   exit(1);
	 }
	 total_mensajes=0;
	 do {
		  fin = fscanf(fp,"%5d",&i);
		  assert(i<MAX_MENSAJES);
		  if (fin != EOF)
				fgets(linea,sizeof(texpr),fp);
		  formatear_linea(linea,mensajes[i]);
		  total_mensajes=i+1>total_mensajes?i+1:total_mensajes; /* VTP. 30/Abr/1997 */
	 } while (!feof(fp));
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void iniciar_claves(void)                                               *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Iniciar el arreglo de palabras claves con el contenido del *
*              archivo de claves.                                         *
* PRE!:  { Nombre es un archivo de mesajes con este formato :             *
*    nnnn   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx                        *
*   Donde nnnn es el numero del mensaje y xxxxxxx es el mensaje           *
*    or  nombre es espacio or nombre no corresponde a ningun archivo      *
* POST!: { Si nombre es correcto carga el archivo de mensajes, si es      *
*          vacio o incorrecto, carga el archivo claves.msg                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void iniciar_claves(void)
{/*----------------------------------------------------------------------*/

	 FILE   *fp;
	 texpr  archivo;
	 texpr  linea;
	 int    i,fin;


	 for (i=0;i<MAX_CLAVES;i++) {
		strcpy(claves[i],"\0");
		strcpy(claves_manta[i],"\0"); 
	 }
	 sprintf(archivo,"%s/%s",direct[0],direct[9]);
	 fp = fopen(archivo,"r");
	 if (fp == NULL) {
		  escriba_cadena("Problemas con el archivo de claves",2);
		  return;
	 }
	 do {
		fin = fscanf(fp,"%5d",&i);
		if (fin != EOF) {
			fgets(linea,sizeof(texpr),fp);
			formatear_linea(linea,claves[i]);
		}
	 } while (!feof(fp));

	 sprintf(archivo,"%s/claves_m.msg",direct[0]);
	 /* VTP. 30/Abr/1997 Decia claves_manta.msg */
	 fp = fopen(archivo,"r");
	 if (fp == NULL)  {
		escriba_cadena("Problemas con el archivo de claves de Manta",2);
		return;
	 }
	 do {
		fin = fscanf(fp,"%5d",&i);
		if (fin != EOF) {
			fgets(linea,sizeof(texpr),fp);
			formatear_linea(linea,claves_manta[i]);
		}
	 } while (!feof(fp)); 
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void iniciar_editor_direct(cad20 nombre)	    			  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Iniciar el arreglo editor, y direc                         *
*              archivo D_MANTA/D_MESAGE/nombre.                           *
* PRE!:  El archivo nombre contiene la informacion de un editor, con el   *
*        siguiente formato :                                              *
* 1. linea : Nombre del editor                                            *
* 2. linea : Opcion para ir a una linea                                   *
* 3. linea : Opcion de editar read-only                                   *
* POST!: { editor[0] = nombre del editor,                                 *
*          editor[1] = opcion para ir a una linea                         *
*          editor[2] = opcion para editar read-only }                     *
* OJO : Si el nombre no corresponde a un archivo, se carga el editor vi   *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void iniciar_editor_direct(cad20 nombre)
{/*----------------------------------------------------------------------*/
	 FILE   *fp;
	 texpr  linea;
	 int    i;
	 cad5   flag;

	 assert(nombre!=NULL && strlen(nombre)<20); /* VTP. 23/Abr/1997 */

	 for (i=0;i!=5;i++)
		  strcpy(editor[i],"\0");
	 for (i=0;i!=20;i++)
		  strcpy(direct[i],"\0");

	 fp = fopen(nombre,"r");
	 if (fp != NULL) {
		fgets(linea,sizeof(texpr),fp);  /* toma el flag_emacs que dice si
					 emacs hace la interfaz o no */
		formatear_linea(linea,flag);
		if (!strcmp(flag,"1"))
			flag_emacs = 1;
		else
			flag_emacs = 0;
		fgets(linea,sizeof(texpr),fp);
		for( i = 0; i < 3; i++) {
			formatear_linea(linea,editor[i]);
			fgets(linea,sizeof(texpr),fp);
		}
		for( i = 0; !feof(fp); i++) {
			formatear_linea(linea,direct[i]);
			fgets(linea,sizeof(texpr),fp);
		}
	 }
	 else {
		escriba_cadena("No pudo abrir archivo de configuracion",2);
	 }
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void lea_cadena(cad50 cad_resp)		                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Leer una cadena de caracteres de pantalla.                 *
* PARAMETROS:                                                             *
*   cad12 	cad_resp	Cadena en la que se retorna la secuencia  *
*				de caracteres leidos.			  *
* PRE!:  { True }                                                         *
* POST!: { cad_resp = CL cadena leida por pantalla   }                    *
*	                                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 15-Ene-90 *
**************************************************************************/

void lea_cadena(cad12 cad_resp)
{/*----------------------------------------------------------------------*/
	 assert(cad_resp!=NULL); /* VTP. 23/Abr/1997 */
	 fgets(cad_resp,45,stdin);
	 if (cad_resp[strlen(cad_resp)-1]=='\n')
	   { cad_resp[strlen(cad_resp)-1]='\0'; }
/*----------------------------------------------------------------------*/}

/**************************************************************************
* char lea_caracter()		                                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Leer un caracter de pantalla.                              *
* PARAMETROS:                                                             *
* PRE!:  { True }                                                         *
* POST!: { retorna el caracter digitado por el usuario   }                *
*	                                                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 15-Ene-90 *
**************************************************************************/

char lea_caracter()
{/*----------------------------------------------------------------------*/
	 int i;

	 i = getchar();
	 getchar();
	 return((char) i);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void lea_nombre(cad20 mensaje,cad12 nombre)                             *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Leer una cadena en una ventana de captura.                 *
* DESCRIPCION: Despliga una nueva ventana en la pantalla,escribe <mensaje>*
*        dentro de ella y lee una cadena de caracteres.                   *
* PARAMETROS:                                                             *
*    cad20	mensaje		Titulo de la captura de datos.		  *
*    cad12      nombre          Cadena leida.                             *
* PRE!:  { mensaje = MS							} *
* POST!: { nombre = NM nombre leido por pantalla.                       } *
* LLAMA A:     void    lea_cadena 		                          *
**************************************************************************/

void lea_nombre(cad50 mensaje,cad12 nombre)
{/*----------------------------------------------------------------------*/
	 cad50     men;

	 assert(mensaje!=NULL);
	 assert(strlen(mensaje)<50);
	 assert(nombre!=NULL); /* VTP. 30/Abr/1997 */


	 if (flag_emacs)
		pedir_nombre(mensaje,nombre);
	 else {
		sprintf(men,"%s: ",mensaje);
		escriba_cadena(men,0);
		lea_cadena(nombre);
	 }
/*----------------------------------------------------------------------*/}

/************************************************************************
* void llenar_menu(ptr_menu m, nodo_nombre *lis)                        *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:  m = un menu, lis = una lista de nombres.                        *
* POST: Se ha llenado el menu m, con la lista lis. Se retorna la ultima *
*       posicion en la lista, que se desplego en pantalla.              *
************************************************************************/

void llenar_menu(ptr_menu m, nodo_nombre *lis)
{/*--------------------------------------------------------------------*/
	 nodo_nombre *l;
	 opcion      op;
	 int         num_op;

	 assert(m!=NULL && lis!=NULL); /* VTP. 23/Abr/1997 */

	 m->num_op = 0;
	 m->act_op = 0;
	 for (num_op = 0, l = lis;l != NULL; l = l->sig,num_op++) {
	   op = crear_opcion(l->nombre);
	   op->longitud = CAD-1;
	   adic_opcion(m,op);
	 }
/*--------------------------------------------------------------------*/}


/**************************************************************************
* void opcion_inactiva()						  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Informar que una opcion esta inactiva.                     *
* DESCRIPCION: Despliega una nueva ventana en la pantalla e informa al u- *
*        rio que la opcion que acaba de seleccionar esta inactiva. Espera *
*        un momento y oculta la ventana.                                  *
* PRE!:  { El usuario ha seleccionado una opcion inactiva               } *
* POST!: { Se informo al usuario que la opcion que ha seleccionado esta   *
*	   inactiva               					} *
**************************************************************************/

void opcion_inactiva()
{/*----------------------------------------------------------------------*/
	 escriba_mensaje(27);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* int opcion_valida(ptr_menu m, texpr comando)                            *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Verificar si <comando> es una opcion valida del menu m     *
* DESCRIPCION: Verifica que <comando> sea un prefijo de alguna de las op- *
*   ciones del menu <num_menu>.                                           *
* POST : opcion_valida = NO_OPCION, si m no tiene la opcion comando       *
*        opcion_valida = Numero de la opcion del menu m, que corresponde  *
*                        a comando.                                       *
**************************************************************************/

int opcion_valida(ptr_menu m,texpr comando)
{/*----------------------------------------------------------------------*/
	 int i;

	 assert(m!=NULL && comando!=NULL); /* VTP. 23/Abr/1997 */

	 if (!strcmp(comando,""))
		  return(NO_OPCION);
	 for (i = 0; 
	      i < m->num_op &&!es_prefijo(comando,m->opciones[i]->nombre);
	      i++);
	 return(i);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void pase_mayusculas(texpr linea)					  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Pasa a mayusculas todas las letras en la cadena <linea>.   *
* PARAMETROS: texpr  linea          String a ser convertido a mayusculas. *
* PRE!:  { linea = "a1 .. an" }.                                          *
* POST!: { linea = "mayuscula(a1) .. mayuscula(an)" }.                    *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 25-Ene-90 *
**************************************************************************/

void pase_mayusculas(texpr linea)
{/*----------------------------------------------------------------------*/
  int i;
  assert(linea!=NULL && strlen(linea)<MAX_TEXPR); /* VTP. 23/Abr/1997 */
	 for (i=0; linea[i] != '\0' ; i++)
		linea[i] = (char)toupper(linea[i])
	 ;
/*----------------------------------------------------------------------*/}



/**************************************************************************
* void esc_nom_tad_actual()						  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Escribir en pantalla el nombre y tipo del tad actual.      *
* DESCRIPCION: Escribe el nombre y la informacion de los padres (en caso  *
*        de que el tad_actual sea derivado de otros) del tad_actual.      *
* V.GLOBALES:                                                             *
*    nodo_tad	*tad_actual	Apunt. al tad actual de la lista de tads  *
*				del ambiente.				  *
* PRE!:  { tad -> <t1,t2,...,tn> <- ult_tad, donde t1,...,tn son los tads *
*          en el ambiente, n >= 2, tad_actual -> ti,  1 <= i <= n       } *
* POST!: { Aparece en pantalla el nombre del tad_actual y su tipo (en caso*
*	    de que no sea normal o inductivo) asi:          		  *
*           <nom tad_actual> |                                  	  *
*           <nom tad_actual>  =  <nom padre 1> x <nom padre 2> |	  *
*                                <nom padre> : <predic. de restriccion> | *
*                                <nom padre> + <nom elem. de completac.> |*
*                                <nom padre 1> + <nom padre 2>  	  *
*                                <nom padre 1> U <nom padre 2>  	} *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 15-Ene-90 *
**************************************************************************/

void esc_nom_tad_actual()
{/*----------------------------------------------------------------------*/

  texpr  nom_tad;
  cad6 siga;

  assert(tad_actual!=NULL);
	 switch (tad_actual->tipo) {
		case PROD_CARTESIANO:
		  sprintf(nom_tad," %s = %s x %s ",
			tad_actual->nombre,
			tad_actual->info_tipo->nombre,
			tad_actual->info_tipo->sig->nombre);
	break;
		case RESTRICCION:
		  sprintf(nom_tad," %s = ( %s : %s ) ",
			tad_actual->nombre,
			tad_actual->info_tipo->nombre,
			tad_actual->info_tipo->sig->nombre);
	break;
		case COMPLETACION:
		  sprintf(nom_tad," %s = %s + { %s } ",
			tad_actual->nombre,
			tad_actual->info_tipo->nombre,
			tad_actual->info_tipo->sig->nombre);
	break;
		case NT_EXTENSION:
		  sprintf(nom_tad," %s = %s + %s ",
			tad_actual->nombre,
			tad_actual->info_tipo->nombre,
			tad_actual->info_tipo->sig->nombre);
	break;
      case VARIACION:
		  sprintf(nom_tad," %s = %s U %s ",
			tad_actual->nombre,
			tad_actual->info_tipo->nombre,
			tad_actual->info_tipo->sig->nombre);
	break;
		case NORMAL:
		default:
		  sprintf(nom_tad," %s ",tad_actual->nombre);
	break;
	 }
  if (flag_emacs) {
	 printf("actualizar-status\n");
	 printf("tipo\n");
	 printf("%s\nfin-objeto",nom_tad);
	 lea_cadena(siga);
  }
  else
	 escriba_mensaje_dinam(nom_tad);
/*----------------------------------------------------------------------*/}



/************************************************************************
* void pintar_menu(ptr_menu m)                                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:  m = un menu                                                     *
* POST: Se ha pintado en pantalla el menu m, con la opcion actual       *
*       en modo reverso.                                                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 17/Jan/92                                            *
************************************************************************/

void pintar_menu(ptr_menu m)
{/*--------------------------------------------------------------------*/
	 int   op;
	 int   longitud;
	 assert(m!=NULL); /* VTP. 23/Abr/1997 */

	 esc_nom_tad_actual();
	 if (flag_emacs) {
		enviar_menu(m);
		return;
	 }

	 longitud=0;

	 printf("_____________________________________________________________________\n");

	 if (strcmp(m->titulo,""))
		printf("%s\n", m->titulo);
	 for (op=0; op < m->num_op; op++) {
		longitud = longitud + strlen(m->opciones[op]->nombre) + 1;
		if (longitud < 70)
	printf("%s ",m->opciones[op]->nombre);
		else {
		  longitud = strlen(m->opciones[op]->nombre) + 1;
	printf("\n%s ",m->opciones[op]->nombre);
		}
	 }
	 printf("\n---------------------------------------------------------------------\n\n");

/*--------------------------------------------------------------------*/}



/************************************************************************
* void enviar_menu(ptr_menu m)                                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:  m = un menu                                                     *
* POST: Se ha enviado al Manejador de interfaz el menu m                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Fecha creacion : 26/Oct/94                                            *
************************************************************************/

void enviar_menu(ptr_menu m)
{/*--------------------------------------------------------------------*/
	 int   op;

	 assert(m!=NULL); /* VTP. 23/Abr/1997 */

	 printf("abrir-menu\n");
	 printf("%d\n%s\n",m->act_op,m->titulo);
	 for (op=0; op < m->num_op; op++)
		printf("%s\n",m->opciones[op]->nombre);
	 printf("fin-objeto");
/*--------------------------------------------------------------------*/}

/**************************************************************************
* void enviar_dir(cad20 dir, cad20 ext)                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO: Desplegar en pantalla el contenido los archivos del          *
*            directorio dir, cuya extension sea ext.                      *
*                                                                         *
**************************************************************************/

void  enviar_dir(cad20 dir, cad20 ext)
{/*----------------------------------------------------------------------*/

	 nodo_nombre *l=NULL;
	 texpr       comando;
	 cad6        siga;
	 int         longitud;

	 assert(dir!=NULL && strlen(dir)<20 && ext!=NULL && strlen(ext)<20); /* VTP. 23/Abr/1997 */

	 sprintf(comando," %s\\*.%s ",dir,ext);
	 printf("mostrar-directorio\n");
	 printf("%s\n",comando);
	 longitud = 0;

	 for (l=lista_dir(dir,ext,0); l != NULL; l = l->sig)
      if ((l->sig == NULL) || (longitud > 50)) {
	printf("%s\n",l->nombre);
	longitud=0;
      }
		else {
	printf("%s ",l->nombre);
	longitud = longitud + strlen(l->nombre) + 1;
      }
	 printf("\nfin-objeto");
    liberar_nombres(&l); 
    lea_cadena(siga);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void enviar_mensaje(int num_mensaje)	                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Enviar un mensaje al manejador de interfaz                 *
*                                                                         *
**************************************************************************/

void enviar_mensaje(int num_mensaje)
{/*----------------------------------------------------------------------*/
  texpr  mensaje;
  cad6   siga;

  assert(num_mensaje>0 && num_mensaje<total_mensajes); /* VTP. 23/Abr/1997 */

  if (strchr(mensajes[num_mensaje],'?') != NULL)    /* es pregunta */
	 strcpy(mensaje,"mostrar-pregunta\n");
  else
	 strcpy(mensaje,"mostrar-mensaje\n");
  strcat(mensaje,mensajes[num_mensaje]);
  strcat(mensaje,"\nfin-objeto");
  printf("%s",mensaje);
  lea_cadena(siga);
/*----------------------------------------------------------------------*/}


/**************************************************************************
* void pedir_nombre(cad20 mensaje,cad12 nombre)                           *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Leer una cadena en una ventana de captura.                 *
* DESCRIPCION: Despliga una nueva ventana en la pantalla,escribe <mensaje>*
*        dentro de ella y lee una cadena de caracteres.                   *
* PARAMETROS:                                                             *
*    cad20	mensaje		Titulo de la captura de datos.		  *
*    cad12      nombre          Cadena leida.                             *
* PRE!:  { mensaje = MS							} *
* POST!: { nombre = NM nombre leido por pantalla.                       } *
* LLAMA A:     void    lea_cadena 		                          *
**************************************************************************/

void pedir_nombre(cad20 mensaje,cad12 nombre)
{/*----------------------------------------------------------------------*/
	 assert(mensaje!=NULL && strlen(mensaje)<20
				&& nombre!=NULL && strlen(nombre)<20); /* VTP. 23/Abr/1997 */

	 printf("pedir-nombre\n");
	 printf("%s : \n",mensaje);
	 printf("fin-objeto");
	 lea_cadena(nombre);
/*----------------------------------------------------------------------*/}


/**************************************************************************
* void llamar_al_editor(cad50 nombre_arch,int modo)                       *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   presentarle al usuario un archivo 
* DESCRIPCION: 
* PARAMETROS:
*    cad50	nombre_arch	nombre del archivo a mostrar
*    int        modo            0 es "read-only"; 1 es "read-write"
* PRE!:
* POST!:
* LLAMA A:
* MODIFICACIONES
* VTP 13/Ene/96 
*      Antes esta funcion asumia que el editor permitia
*      ir a una linea o abrir un archivo solo-lectura, ahora
*      si estas opciones estan vacias en el archivo de configuracion
*      no las usa 
*      Funciona bien tanto en UNIX como en DOS
**************************************************************************/

void llamar_al_editor(int num_archs, trio_edicion edicion[MAX_EDICION],
		      cad50 p_emacs)
{/*----------------------------------------------------------------------*/
  texpr     comando;
  texpr     rcom;
  cad6      siga;
  int       i;
  int carc,pcarc,ucarc,readOnly;
  FILE *arc;
  char *narc;

  assert(p_emacs!=NULL && strlen(p_emacs)<50); /* VTP. 23/Abr/1997 */

  if (flag_emacs) {
	 printf("mostrar-archivo\n%d\n",num_archs);
	 for (i=0; i < num_archs; i++)
		printf("%d\n%d\n%s\n",edicion[i].modo,edicion[i].linea,
		  edicion[i].nombre);
	 printf("fin-objeto");
	 lea_cadena(siga);
	 return;
  }
  /* Si no hay editor externo, emplear uno super-prehistorico (stdin) */
  if (*editor[0]=='\0')
    {
      if (num_archs==1)
	{ narc=edicion[0].nombre; readOnly=!edicion[0].modo; }
      else
	{ narc=edicion[1].nombre; readOnly=!edicion[1].modo; }
      /* Primero se muestra el archivo */
      if ((arc=fopen(narc,"rt"))!=NULL)
	{
	  while ((carc=getc(arc))!=EOF)
	    { putchar((char)carc); }
	  fclose(arc);
	}
      /* Despues y en caso de que no sea solo lectura.  
	 Se lee de entrada estandar y se escribe en el archivo */
      if (!readOnly && (arc=fopen(narc,"wt"))!=NULL)
	{
	  pcarc=ucarc=-1;
	  carc=getchar();
	  while (carc!=EOF && !(pcarc=='\n' && ucarc=='\n' && carc=='\n'))
	    { 
	      putc((char)carc,arc);
	      pcarc=ucarc;
	      ucarc=carc;
	      carc=getchar();
	    }
	  fclose(arc);
	}
      return;
    }
  switch (num_archs) {
  case 1:
    if (edicion[0].modo) {        /* modificable */
      sprintf(comando, "%s ",editor[0]);
      if (*editor[1]) {
	sprintf(rcom, "%s%d ",editor[1],edicion[0].linea);
	strcat(comando,rcom);
      }
      transArch2(edicion[0].nombre);
      sprintf(rcom,"%s%s",comando,edicion[0].nombre);
      strcpy(comando,rcom);
      comando[strlen(rcom)]='\0';
    }
    else {
      sprintf(comando, "%s ",editor[0]);
      if (*editor[2]) {
	sprintf(rcom,"%s ",editor[2]);
	strcat(comando,rcom);
      }
      transArch2(edicion[0].nombre);
      sprintf(rcom,"%s%s",comando,edicion[0].nombre);
      strcpy(comando,rcom);
      comando[strlen(rcom)]='\0';
    }
    transArch(comando);
    system(comando);
    break;
  case 2:
    if (strcmp(editor[0],"emacs")) { /* el editor NO ES EMACS */
      if (edicion[1].modo) {      /* modificable */
	sprintf(comando, "%s ",editor[0]);
	if (*editor[1]) {
	  sprintf(rcom, "%s%d ",editor[1],edicion[1].linea);
	  strcat(comando,rcom);
	}
	strcat(comando,edicion[1].nombre);
      }
      else {
	sprintf(comando, "%s ",editor[0]);
	if (*editor[2]) {
	  sprintf(rcom,"%s ",editor[2]);
	  strcat(comando,rcom);
	}
	strcat(comando,edicion[1].nombre);
      }
    }
    else   {                        /* el editor ES EMACS */
      if (edicion[1].modo)         /* modificable */
	sprintf(comando,"%s -l %s %s%d %s",editor[0],p_emacs,
		editor[1],edicion[1].linea,edicion[1].nombre);
      else
	sprintf(comando,"%s -l %s %s %s",editor[0],p_emacs,editor[2],
		edicion[1].nombre);
    }
    transArch(comando);
    system(comando);
    break;
  default:
    break;
  }
/*----------------------------------------------------------------------*/}


/**************************************************************************
* void enviar_mensaje_dinamico(texpr mensaje)                             *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Enviar un mensaje dinamico al manejador de interfaz        *
*                                                                         *
**************************************************************************/

void enviar_mensaje_dinamico(texpr mensaje)
{/*----------------------------------------------------------------------*/
  cad6    siga;

  assert(mensaje!=NULL && strlen(mensaje)<=MAX_TEXPR); /* VTP. 23/Abr/1997 */

  if (strchr(mensaje,'?') != NULL)       /* es pregunta */
	 printf("mostrar-pregunta\n");
  else
	 printf("mostrar-mensaje\n");
  printf("%s\n",mensaje);
  printf("fin-objeto");
  lea_cadena(siga);
/*----------------------------------------------------------------------*/}


