  /* DEFINICION.H			      				*/

#ifndef definic_h
#define definic_h

/* TECNICAS PARA PREVENIR Y CORREGIR PROBLEMAS */
/* VTP. 15/Abr/1997 */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
extern char CadErrorAssert[200];

#define FileOpen(f,nom) if ((f)==NULL) { \
sprintf(CadErrorAssert,"No pudo abrir archivo %s. Fuente: %s, Linea: %d"\
		  ,nom,__FILE__, __LINE__);\
		  escriba_cadena(CadErrorAssert,2);exit(1);}
/* HayMem(p,s) - Verifica que p tenga memoria asignada y lo inicializa */
/* p es un apuntador recien creado, s el tamao de la estrucutra */
/* OJO: Esto borrar el espacio de memoria apuntado por p de tamao s */
#define HayMem(p,s) if ((p)==NULL) { sprintf(CadErrorAssert,"No hay memoria suficiente. Fuente: %s, Linea: %d",__FILE__, __LINE__); escriba_cadena(CadErrorAssert,2);exit(1);}memset(p,0,s);

/* VERSION DEL KERNEL */
/* La definicion esta en el archivo man_tipo.c que
   en el directorio D_TIPOS*/

extern char VersionKernelManta[20];

/*----------------------------------------------------------------------*/
/* Declaracion de Constantes Simbolicas					*/
/*----------------------------------------------------------------------*/


/********** Constantes para administracion de la tabla de simbolos **********/
#define SYM_ADT 1
#define SYM_INITIAL 2
#define SYM_CONSTRUCTOR 3
#define SYM_SELECTOR 4

/********** Constantes Simbolicas Del Modulo de Definicion de Tipos **********/
#define MAX_MENSAJES          300
#define MAX_CLAVES             30
#define MAX_MENUS              30
#define LIN_ESPERAR           ">+"
#define LINEA_MENSAJE          23
#define CAD                    40
#define MAX_EDICION            3

#define MAX_TEXPR	 6000
/* VTP. 30/Abr/1997 */

/*-- Constantes que identifican los menus del sistema --*/
#define MANTA			0
#define TIPOS			1
#define REPRESENTACIONES        2
#define TEOREMAS                3
#define PROTOTIPOS              4
#define EDICION                 5
#define STATUS                  6
#define TIPO_SUM_DIREC          7
#define NUEVO_TAD               8
#define NUEVA_REPRESENT         9
#define EDICION_REPRESENT      10
#define NUEVO_PROTOTIPO        11
#define AXIOMAS                12
#define TADS_AMBIENTE          13
#define TADS_DIRECTORIO        14
#define PARAMETROS             15
#define REPRESENTS_AMBIENTE    16
#define REPRESENTS_DIRECTORIO  17
#define AXIOMAS_REPRESENT      18
#define CONJ_DIRECTORIO        19
#define PROT_EDICION           20

#define NORMAL                  1
#define PROD_CARTESIANO		2
#define RESTRICCION		3
#define NT_EXTENSION               4 
/***VTP. 7/Mar/1997. Renombrado de EXTENSION. 
         Se hizo por conflicto con dir.h del DJGPP ***/
#define COMPLETACION		5
#define VARIACION		6
#define REPRESENTACION          7
/* VTP 11/May/1998.  Agregado el tipo REPRESENTACION */

/********** Constantes Simbolicas Del Modulo de Definicion de Tipos **********/

#define MAX_LEFTMOST_REWRITE 20000

/*----------------------------------------------------------------------*/
/* Definicion de Macros                					*/
/*----------------------------------------------------------------------*/

#define cursor(f,c) printf("\033[%d;%dH",f,c)

/*----------------------------------------------------------------------*/
/* Definicion de Nuevos Tipos de Datos 					*/
/*----------------------------------------------------------------------*/

typedef struct trioedicion {     /* datos para editar un archivo */
  int    modo;
  int    linea;
  char   nombre[CAD];
} trio_edicion;

/*************  Tipos de Datos del Modulo de Definicion de Tipos **********/

typedef char cad5[5];

typedef char cad6[6];

typedef char cad12[CAD];

typedef char cad16[CAD];

typedef char cad20[CAD];

typedef char cad50[50];

typedef char texpr[MAX_TEXPR];

typedef char cad240[MAX_TEXPR];


typedef struct nodonombre {
	cad50			nombre;
	struct nodonombre	*sig;
	} nodo_nombre;

/** La clase de una expresion puede ser :
    "VAR"    Variable 
    "INIC"   Inicial
    "CONSTR" Constructor
    "SELECT" Selectora
    "EQUAL"  Axioma de igualdad  
    "ERROR"  La palabra clave ERROR

VTP. 5/Jun/1998   Ya no puede ser:
    "F_REP"  Funcion de representacion
    "OP_AUX" Operacion auxiliar
**/

/** El tipo puede ser :
    "BOOL"   Booleano 
    "NAT"    Natural
    Cualquier tipo definido por el usuario   **/

typedef struct nodoexpresion {
	cad12			nombre;
	cad20			tipo;
	cad12 			clase; /*** VTP. Abr/9/1997 ***/
	/*** Decia cad6, pero como notara las cadenas de clase
	     incluyendo el \0 tienen hasta 7 caracteres, esto 
	     producia en algunas maquinas un error tenaz porque
             cambiaba el siguiente campo de la estructura */
	struct nodoargum	*argumentos;
	} nodo_expresion;

typedef struct nodoargum {
	nodo_expresion		*expr;
	struct nodoargum	*sig;
	} nodo_argum;

typedef struct nodoigualdad {
	texpr			li_str,
				ld_str;
	nodo_expresion		*lado_izq,
				*lado_der;
	struct nodoigualdad	*sig;
	} nodo_igualdad;

typedef struct nodogeneradora{
	cad12			nombre;
        cad12                   nombre_fte; /*-- 
					      Si fue creada automaticamente :
					        Nombre de la selectora  
                                                de la cual se creo.
                                              Si no : es igual a nombre 
						 --*/
	nodo_nombre		*dominio;
	struct nodogeneradora	*sig;
	} nodo_generadora;

typedef struct nododom {
	cad12			nombre;
	short			induccion;
	struct nododom		*sig;
	} nodo_dom;

typedef struct nodoselect {
	cad12			nombre;
        cad12                   nombre_fte; /*-- 
					      Si fue creada automaticamente :
					        Nombre de la selectora  
                                                de la cual se creo.
                                              Si no : es igual a nombre.
                                            --*/
	nodo_dom		*dominio;
	cad20			codominio;
	short			caracterizadora;
	nodo_igualdad		*axiomas;
	struct nodoselect	*sig;
	} nodo_select;
  
typedef struct nodotad {
	cad12			nombre; /*-- Nombre del tad --*/
	short			status, /*-- 1 = MODIFICABLE, 
                                             0 = NO_MODIFICABLE --*/
				tipo;   /*-- NORMAL, PROD_CART,etc --*/
        int                     modif;  /*-- Indica si ha sido modificado,
                                             para salvarlo.         --*/
	nodo_nombre	 	*info_tipo, /*-- Tipos que los generan --*/
	              		*parametros;/*-- Tipos parametros     --*/
	nodo_generadora		*iniciales, /*-- Iniciales --*/
				*constructoras; /*-- Constructoras --*/
	nodo_select		*selectoras; /*-- Selectoras --*/
	struct nodotad		*sig; /*-- Siguiente tad --*/
	} nodo_tad;

typedef struct nodocomponente {
    	texpr			nombre,
				tipo,
				clase;
	struct nodocomponente	*sig;
	} nodo_componente;

typedef struct nodotupla {
	nodo_componente		*componentes;
	struct nodotupla	*sig;
	} nodo_tupla;


/*************  Implantacion de la Estructura Computacional TABLA *********/
/** Una tabla es una lista de la siguiente forma :
    TAB --> [<tipo,null>,<sel1,it1>..<seln,itn>]
    Donde :
    tipo es un identificador de la tabla
    seli es una llave ( cadena de caracteres ) del item i
    iti  es una expresion con el contenido del item i ***/

typedef struct nodoentrada {
        cad12           selector;
        nodo_expresion  *item;
        } nodo_entrada;

typedef struct nodotabla {
        nodo_entrada      *entrada;
	struct nodotabla  *sig;
	} nodo_tabla, *Ptr_tabla;

/************* Definicion de una Lista de Historia de Demostraciones ****/

typedef struct nodohistoria {
        nodo_expresion *expr;    /*-- Expresion que se reescrita  --*/
        nodo_igualdad  *regla;   /*-- Regla que la reescribio     --*/
        cad12          nivel;    /*-- Nivel de induccion al que   --*/
                                 /*-- pertenece la expresion.     --*/
        struct nodohistoria *sig;/*-- Siguiente historia.         --*/
       } nodo_historia;

typedef struct nododemost {
        nodo_historia *his_li;   /*-- Historia del lado izquierdo --*/  
        nodo_historia *ult_li;   /*-- Ultimo   del lado izquierdo --*/  
	nodo_historia *his_ld;   /*-- Historia del lado derecho   --*/
        nodo_historia *ult_ld;   /*-- Ultimo   del lado derecho   --*/  
	struct nododemost *sig;  /*-- Apuntador sig.  demostracion--*/
} nodo_demost;

/*-- Defincion de la estructora de Menus del programa                 --*/

       /*------------------------------------------------------+
       |                      CONSTANTES                       |
       +------------------------------------------------------*/
 
/* #define MAX_OP         25  -- Numero maximo de opciones del menu --*/
#define MAX_COL        70  /*-- Numero maximo de columnas          --*/
#define LONG_CAD       80  /*-- Longitud maxima de una cadena      --*/
#define NO_OPCION      -1  /*-- No se digito ninguna opcion        --*/

       /*------------------------------------------------------+
       |                         TIPOS                         |
       +------------------------------------------------------*/

typedef struct sopcion {
      char    nombre[CAD];     /*-- Cadena del nombre de una opcion --*/
      int     longitud;        /*-- Longitud de la opcion           --*/
}  *opcion;


typedef struct sptr_menu{
      int     num_op;  /*-- Numero de opciones del menu              --*/
      int     act_op;  /*-- Opcion actual del menu                   --*/
      char    titulo[2*CAD]; /*-- Titulo del menu               --*/
      opcion  *opciones; /*-- Opciones del menu               --*/ 
} *ptr_menu;

/*----------------------------------------------------------------------*/
/* Definicion de todas las rutinas del Programa				*/
/*----------------------------------------------------------------------*/

#include "enc_tipo.h"
/* VTP. 3/Jun/98 Representacion cambiado */
#include "enc_teo.h"
#include "enc_prot.h"

/*--------------------------------------------------------------*/
/* Definicion  de las Estructuras de Datos Globales		*/
/*--------------------------------------------------------------*/

/*************  Definicion de arreglo donde se guardan los mensajes *******/

extern texpr mensajes[MAX_MENSAJES];
extern int total_mensajes; /* VTP. 30/Abr/1997 Numero de Mensajes */
extern texpr claves[MAX_CLAVES];
extern texpr claves_manta[MAX_CLAVES];

extern int  flag_emacs;         /* permite saber si opera la interfaz emacs */

/*************  Datos Globales del Modulo de Definicion de Tipos **********/

extern nodo_tad		*tad;		/* Apunt. a la lista de TADs 	  */

extern nodo_tad         *symtable;     /* Tabla de simbolos. VTP 4/May/1998 */

extern nodo_tad		*ult_tad;       /* Apunt. al ult. TAD de la lista */

extern nodo_tad		*tad_actual;    /* Apunt. al TAD procesado actual */

extern nodo_tad		*tad_ed;        /* Apunt. al TAD editado actual   */

extern cad20            editor[5];      /* Parametros del editor          */

extern cad20            direct[255];     /* Directorios usados por manta   */

extern texpr            nombre_usuario; /* Nombre del usuario             */

extern int 		fila,columna;

extern texpr		token;

extern int		num_ed;		/* Num. de la linea siendo editada*/

extern short		desea_ayuda_tuplas_comp;  /* 1, Si el usuario desea */
                                                  /* ayuda, 0, Sino.  */
extern cad50		posic_param_incompl;
					/* Posicion en notac. del argum. */
					/* no completo dentro del arbol  */
					/* de la expresion.		 */


extern nodo_nombre	*parametros;	/* Apunt. a la lista de parametros*/
					/* se desea desplegar en el menu  */
					/* de parametros 	          */


/*************  Datos Globales del Modulo de Representaciones    **********/

/* VTP. 3/Jun/1998 Todo el esquema para hacer representaciones se cambio */
/* Hay una lista de tipos (tad) que tambien tiene las representaciones  */


/******************* Datos Globales del Modulo de Teoremas ******************/

extern nodo_demost *unproved;     /*-- Lista de conjeturas no probadas. --*/
extern nodo_demost *ult_unproved; /*-- Ultima no probada.               --*/

extern nodo_demost *proved;       /*-- Lista de conjeturas probadas.    --*/
extern nodo_demost *ult_proved;   /*-- Ultima probada.                  --*/

extern nodo_igualdad *especiales; /*-- Son reglas que se aplican con    --*/
                                  /*-- politicas especiales.            --*/

extern nodo_igualdad *ifrules;  /* if rules */
extern nodo_igualdad *eqrefl; /* EQUAL rules */


/******************* Variables globales de MENUS  ******************/

extern ptr_menu menus_manta[MAX_MENUS]; /*-- Menus del programa          --*/

#endif
