/************************************************************************
* Module : LConstructor                   File: LConstructor.c          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* This file contains the source code of the ADT'S functions             *
*************************************************************************
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
       /*-------------------------------------------------------+
       | Inclusion of standard libraries                        |
       +-------------------------------------------------------*/
 
#include <stdio.h>
#include <ctype.h>
#include <malloc.h>
#include <assert.h>
#include <stdlib.h>
#include "manta.h"
 
       /*-------------------------------------------------------+
       | Inclusion of Constants, Types, Macros and module's     |
       | parameter ADTS.                                        |
       +-------------------------------------------------------*/
 
#include "Char_de.h"
#include "Constructor_de.h"
#include "Domain_de.h"
#include "LConstructor_de.h"
#include "LDomain_de.h"
#include "String_de.h"
 
       /*-------------------------------------------------------+
       | Inclusion of the project's extern functions prototypes |
       +-------------------------------------------------------*/
 
#include "Char.h"
#include "Constructor.h"
#include "Domain.h"
#include "LConstructor.h"
#include "LDomain.h"
#include "String.h"
 
        /*------------------------------------------------------+
        | Inclusion of the module's constructor functions       |
        +------------------------------------------------------*/
 
#include "LConstructor_co.inc"
 
        /*------------------------------------------------------+
        |      Definition of the functions of this module       |
        +------------------------------------------------------*/
 
/************************************************************************
Constructor 	head_LConstructor(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
Constructor 	head_LConstructor(LConstructor L0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( (Constructor)ERROR("head_LConstructor") );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    return( pr0cons_LConstructor(L0) );
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
LConstructor 	tail_LConstructor(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
LConstructor 	tail_LConstructor(LConstructor L0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( (LConstructor)ERROR("tail_LConstructor") );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    return( pr1cons_LConstructor(L0) );
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
int 	length_LConstructor(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
int 	length_LConstructor(LConstructor L0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( 0 );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    return( length_LConstructor(pr1cons_LConstructor(L0))+ 1 );
  }

  return 0;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
LConstructor 	concat_LConstructor(LConstructor L0, LConstructor L1)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
LConstructor 	concat_LConstructor(LConstructor L0, LConstructor L1)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( copiar_obj_LConstructor(L1) );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    return( cons_LConstructor(copiar_obj_Constructor(pr0cons_LConstructor(L0)), concat_LConstructor(pr1cons_LConstructor(L0), L1)) );
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
BOOL 	isEmptyList_LConstructor(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
BOOL 	isEmptyList_LConstructor(LConstructor L0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( TRUE );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    return( FALSE );
  }

  return FALSE;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	stringINITIALS(void)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String 	stringINITIALS(void)
{/*--------------------------------------------------------------------*/
  return( cons_String(charOfNAT(73), cons_String(charOfNAT(78), cons_String(charOfNAT(73), cons_String(charOfNAT(84), cons_String(charOfNAT(73), cons_String(charOfNAT(65), cons_String(charOfNAT(76), cons_String(charOfNAT(83), cons_String(charOfNAT(10), nil_String()))))))))) );

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	stringRUCTORS(void)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String 	stringRUCTORS(void)
{/*--------------------------------------------------------------------*/
  return( cons_String(charOfNAT(82), cons_String(charOfNAT(85), cons_String(charOfNAT(67), cons_String(charOfNAT(84), cons_String(charOfNAT(79), cons_String(charOfNAT(82), cons_String(charOfNAT(83), cons_String(charOfNAT(10), nil_String())))))))) );

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	prettyLInitial(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String 	prettyLInitial(LConstructor L0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( nil_String() );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    if ( isInitialConstructor(pr0cons_LConstructor(L0)) ) {
      return( ( isEmptyList_LConstructor(pr1cons_LConstructor(L0)) ) ? prettyConstructor(pr0cons_LConstructor(L0)) : concat_String(prettyConstructor(pr0cons_LConstructor(L0)), concat_String(cons_String(charOfNAT(10), nil_String()), prettyLInitial(pr1cons_LConstructor(L0)))) );
    } else {
      return( nil_String() );
    }
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	prettyLCons(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String 	prettyLCons(LConstructor L0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) ){
    return( nil_String() );
  }
  else if ( is_cons_LConstructor( L0 ) ){
    if ( !(isInitialConstructor(pr0cons_LConstructor(L0))) ) {
      return( ( isEmptyList_LConstructor(pr1cons_LConstructor(L0)) ) ? prettyConstructor(pr0cons_LConstructor(L0)) : concat_String(prettyConstructor(pr0cons_LConstructor(L0)), concat_String(cons_String(charOfNAT(10), nil_String()), prettyLCons(pr1cons_LConstructor(L0)))) );
    } else {
      return( nil_String() );
    }
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	prettyLConstructor(LConstructor L0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
String 	prettyLConstructor(LConstructor L0)
{/*--------------------------------------------------------------------*/
  return( concat_String(stringINITIALS(), concat_String(prettyLInitial(L0), concat_String(cons_String(charOfNAT(10), cons_String(charOfNAT(67), cons_String(charOfNAT(79), cons_String(charOfNAT(78), cons_String(charOfNAT(83), cons_String(charOfNAT(84), nil_String())))))), concat_String(stringRUCTORS(), prettyLCons(L0))))) );

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
BOOL 	EQ_LConstructor(LConstructor L0, LConstructor L1)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
BOOL 	EQ_LConstructor(LConstructor L0, LConstructor L1)
{/*--------------------------------------------------------------------*/
  if ( is_nil_LConstructor( L0 ) && 
	is_nil_LConstructor( L1 ) ){
    return( TRUE );
  }
  else if ( is_nil_LConstructor( L0 ) && 
	is_cons_LConstructor( L1 ) ){
    return( FALSE );
  }
  else if ( is_cons_LConstructor( L0 ) && 
	is_nil_LConstructor( L1 ) ){
    return( FALSE );
  }
  else if ( is_cons_LConstructor( L0 ) && 
	is_cons_LConstructor( L1 ) ){
    return( (EQ_Constructor(pr0cons_LConstructor(L0), pr0cons_LConstructor(L1))) &&
	(EQ_LConstructor(pr1cons_LConstructor(L0), pr1cons_LConstructor(L1))) );
  }

  return FALSE;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
LConstructor	copiar_obj_LConstructor(LConstructor o)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
LConstructor	copiar_obj_LConstructor(LConstructor o)
{/*--------------------------------------------------------------------*/
    LConstructor	L_obj;

    if ( is_nil_LConstructor(o) ) {

      L_obj = nil_LConstructor();
    }
    else if ( is_cons_LConstructor(o) ) {
      Constructor	C0;
      LConstructor	L1;

      C0 = copiar_obj_Constructor(pr0cons_LConstructor(o));
      L1 = copiar_obj_LConstructor(pr1cons_LConstructor(o));
      L_obj = cons_LConstructor(C0, L1);
    }
    return ( L_obj );
/*--------------------------------------------------------------------*/}
 
/************************************************************************
void	borrar_obj_LConstructor(LConstructor *o)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
void	borrar_obj_LConstructor(LConstructor *o)
{/*--------------------------------------------------------------------*/
    LConstructor obj;

    obj = (*o);
    if (obj == NULL) return;
    if (uso_obj(obj) > 0) dec_uso(obj);
    if (uso_obj(obj) > 0) return;
    if ( is_nil_LConstructor(obj) ) {

      free(*o);
      (*o)=NULL;
    }
    else if ( is_cons_LConstructor(obj) ) {
      Constructor	C0;
      LConstructor	L1;

      C0 = pr0cons_LConstructor(obj);
      borrar_obj_Constructor(&C0);
      L1 = pr1cons_LConstructor(obj);
      borrar_obj_LConstructor(&L1);
      free(*o);
      (*o)=NULL;
    }
/*--------------------------------------------------------------------*/}
