/************************************************************************
* Module : String                   File: String.c                      *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* This file contains the source code of the ADT'S functions             *
*************************************************************************
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
       /*-------------------------------------------------------+
       | Inclusion of standard libraries                        |
       +-------------------------------------------------------*/
 
#include <stdio.h>
#include <ctype.h>
#include <malloc.h>
#include <assert.h>
#include <stdlib.h>
#include "manta.h"
 
       /*-------------------------------------------------------+
       | Inclusion of Constants, Types, Macros and module's     |
       | parameter ADTS.                                        |
       +-------------------------------------------------------*/
 
#include "Char_de.h"
#include "String_de.h"
 
       /*-------------------------------------------------------+
       | Inclusion of the project's extern functions prototypes |
       +-------------------------------------------------------*/
 
#include "Char.h"
#include "String.h"
 
        /*------------------------------------------------------+
        | Inclusion of the module's constructor functions       |
        +------------------------------------------------------*/
 
#include "String_co.inc"
 
        /*------------------------------------------------------+
        |      Definition of the functions of this module       |
        +------------------------------------------------------*/
 
/************************************************************************
Char 	head_String(String S0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
Char 	head_String(String S0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_String( S0 ) ){
    return( (Char)ERROR("head_String") );
  }
  else if ( is_cons_String( S0 ) ){
    return( pr0cons_String(S0) );
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	tail_String(String S0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String 	tail_String(String S0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_String( S0 ) ){
    return( (String)ERROR("tail_String") );
  }
  else if ( is_cons_String( S0 ) ){
    return( pr1cons_String(S0) );
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
int 	length_String(String S0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
int 	length_String(String S0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_String( S0 ) ){
    return( 0 );
  }
  else if ( is_cons_String( S0 ) ){
    return( length_String(pr1cons_String(S0))+ 1 );
  }

  return 0;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String 	concat_String(String S0, String S1)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String 	concat_String(String S0, String S1)
{/*--------------------------------------------------------------------*/
  if ( is_nil_String( S0 ) ){
    return( copiar_obj_String(S1) );
  }
  else if ( is_cons_String( S0 ) ){
    return( cons_String(copiar_obj_Char(pr0cons_String(S0)), concat_String(pr1cons_String(S0), S1)) );
  }

  return NULL;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
BOOL 	isEmptyList_String(String S0)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
BOOL 	isEmptyList_String(String S0)
{/*--------------------------------------------------------------------*/
  if ( is_nil_String( S0 ) ){
    return( TRUE );
  }
  else if ( is_cons_String( S0 ) ){
    return( FALSE );
  }

  return FALSE;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
BOOL 	EQ_String(String S0, String S1)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
BOOL 	EQ_String(String S0, String S1)
{/*--------------------------------------------------------------------*/
  if ( is_nil_String( S0 ) && 
	is_nil_String( S1 ) ){
    return( TRUE );
  }
  else if ( is_nil_String( S0 ) && 
	is_cons_String( S1 ) ){
    return( FALSE );
  }
  else if ( is_cons_String( S0 ) && 
	is_nil_String( S1 ) ){
    return( FALSE );
  }
  else if ( is_cons_String( S0 ) && 
	is_cons_String( S1 ) ){
    return( (EQ_Char(pr0cons_String(S0), pr0cons_String(S1))) &&
	(EQ_String(pr1cons_String(S0), pr1cons_String(S1))) );
  }

  return FALSE;
/*--------------------------------------------------------------------*/}
 
/************************************************************************
String	copiar_obj_String(String o)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
String	copiar_obj_String(String o)
{/*--------------------------------------------------------------------*/
    String	S_obj;

    if ( is_nil_String(o) ) {

      S_obj = nil_String();
    }
    else if ( is_cons_String(o) ) {
      Char	C0;
      String	S1;

      C0 = copiar_obj_Char(pr0cons_String(o));
      S1 = copiar_obj_String(pr1cons_String(o));
      S_obj = cons_String(C0, S1);
    }
    return ( S_obj );
/*--------------------------------------------------------------------*/}
 
/************************************************************************
void	borrar_obj_String(String *o)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PRE:                                                                  *
* POST:                                                                 *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Author:                                                             *
* Date of creation: 11/Oct/98                                           *
* Generated by : Manta System                                           *
************************************************************************/
 
void	borrar_obj_String(String *o)
{/*--------------------------------------------------------------------*/
    String obj;

    obj = (*o);
    if (obj == NULL) return;
    if (uso_obj(obj) > 0) dec_uso(obj);
    if (uso_obj(obj) > 0) return;
    if ( is_nil_String(obj) ) {

      free(*o);
      (*o)=NULL;
    }
    else if ( is_cons_String(obj) ) {
      Char	C0;
      String	S1;

      C0 = pr0cons_String(obj);
      borrar_obj_Char(&C0);
      S1 = pr1cons_String(obj);
      borrar_obj_String(&S1);
      free(*o);
      (*o)=NULL;
    }
/*--------------------------------------------------------------------*/}
