#----------------------------------------------#
#   TEST PROGRAM GENERATED BY MANTA KERNEL 3.1 #     #
#   Universidad de los Andes                   #
#----------------------------------------------#
# Platform:  Unix                          
#  Written by Vladimir Tamara                  #
#  1998                                        #
#----------------------------------------------#


# DIRECTORIES
###################################################

# Kernel sources
#  Some compilers requiere the entire path (don't use  ~ nor $HOME)
DIRKERNEL= ../../..
# Directory with module os_dep.c (plataform dependent)
DIROSDEP= ../../../plat/unix
# Directory of the test sources
DIRTEST= ../..

# Development tools
#   You can leave this empty and change the environmente variable PATH
#   If you use this, it has to end with / or \ (e.g C:\DJGPP\BIN\ )
TOOLS =


# OPERATING SYSTEM
###################################################

# Copy program
CP=cp
# Copy with directories
XCOPY=cp -rf

# Simple delete programa
RM=rm -f
# Delete directories
DELTREE=rm -rf

#Directory separator	
SEPDIR=/



# COMPILER
###################################################

# Compiler name
CC =$(TOOLS)gcc

# Directories with header files
INCLUDE_KERNEL =-I$(DIRKERNEL) \
		-I$(DIROSDEP) \
		-I$(DIRKERNEL)/d_types \
		-I$(DIRKERNEL)/d_theo \
		-I$(DIRKERNEL)/d_prot

# Linking flags
LFLAGS = -g

# KERNEL 
###################################################

# Kernel Headers
KERNEL_HDR =    $(DIRKERNEL)/declara.h \
		$(DIRKERNEL)/definic.h \
		$(DIRKERNEL)/os_dep.h \
		$(DIRKERNEL)/apimanta.h \
		$(DIRKERNEL)/d_types/enc_tipo.h \
		$(DIRKERNEL)/d_theo/enc_teo.h \
		$(DIRKERNEL)/d_prot/enc_prot.h

# Kernel files
KERNEL_OBJ =    anal_axs.o\
	        anal_sig.o\
	        archivos.o\
	        axiomas.o\
		completa.o\
	        def_tipo.o\
		ed_tipos.o\
		expresio.o\
		extensio.o\
		int_tipo.o\
		lib_list.o\
		man_tipo.o\
		prin_def.o\
		prod_imp.o\
		proy_tad.o\
		restricc.o\
		variacio.o\
		represen.o\
		ana_teo.o\
		man_teo.o\
		sistre.o\
                rewrite.o\
		sustituc.o\
		tabla.o\
		man_prot.o\
		prototip.o\
		symtable.o\
		os_dep.o\
		apimanta.o \
		inter31.o


# APPLICATION
###################################################


APP_INCLUDES=-I.

APP_OBJECTS= Char.o  \
	Char_in.o  \
	String.o \
	String_in.o \
	Parameter.o \
	Parameter_in.o \
	LParameter.o \
	LParameter_in.o \
	Domain.o \
	Domain_in.o \
	LDomain.o \
	LDomain_in.o \
	Expr.o \
	Expr_in.o \
	LExpr.o \
	LExpr_in.o \
	Axiom.o \
	Axiom_in.o \
	LAxiom.o  \
	LAxiom_in.o  \
	Constructor.o \
	Constructor_in.o \
	LConstructor.o \
	LConstructor_in.o \
	Selector.o\
	Selector_in.o\
	LSelector.o \
	LSelector_in.o \
	AbsType.o\
	AbsType_in.o\
	manta.o \
	manta_in.o \
	est2abs.o  \
	prp.o


# COMMON
###################################################

HEADERS = 	$(KERNEL_HDR)\
		$(APP_HEADERS)

OBJECTS  = 	$(KERNEL_OBJ)\
	        $(APP_OBJECTS)

INCLUDES = $(INCLUDE_KERNEL)

# Compiltaion flags (e.g. -c -Wall -DNDEBUG -ansi -pedantic)
#   With DJGPP, gcc v 2.7.2, flag -ansi doesn't work
#   Leave flag -DNDEBUG in final versions
CFLAGS = -g -c $(INCLUDES) -Wall -ansi -pedantic


# RULES TO BUILD APPLICATION
###################################################


compile: prp

clean:
	$(RM) *.o

prp: $(OBJECTS) $(HEADERS)
	$(CC) $(LFLAGS) $(OBJECTS) -o prp



# On top of kernel

apimanta.o: $(DIRKERNEL)/apimanta.c $(DIRKERNEL)/apimanta.h $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/apimanta.c

inter31.o: $(DIRTEST)/inter31.c $(KERNEL_HDR) $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRTEST)/inter31.c


# Plataform dependent modules

os_dep.o :  $(DIROSDEP)/os_dep.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIROSDEP)/os_dep.c


# Kernel modules

symtable.o : $(DIRKERNEL)/d_types/symtable.c $(KERNEL_HDR) 
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/symtable.c

anal_axs.o : $(DIRKERNEL)/d_types/anal_axs.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/anal_axs.c

anal_sig.o : $(DIRKERNEL)/d_types/anal_sig.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/anal_sig.c

archivos.o : $(DIRKERNEL)/d_types/archivos.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/archivos.c

axiomas.o : $(DIRKERNEL)/d_types/axiomas.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/axiomas.c

completa.o : $(DIRKERNEL)/d_types/completa.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/completa.c

def_tipo.o : $(DIRKERNEL)/d_types/def_tipo.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/def_tipo.c

ed_tipos.o : $(DIRKERNEL)/d_types/ed_tipos.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/ed_tipos.c

expresio.o : $(DIRKERNEL)/d_types/expresio.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/expresio.c

extensio.o : $(DIRKERNEL)/d_types/extensio.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/extensio.c

int_tipo.o : $(DIRKERNEL)/d_types/int_tipo.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/int_tipo.c

lib_list.o : $(DIRKERNEL)/d_types/lib_list.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/lib_list.c

man_tipo.o : $(DIRKERNEL)/d_types/man_tipo.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/man_tipo.c

prin_def.o : $(DIRKERNEL)/d_types/prin_def.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/prin_def.c

prod_imp.o : $(DIRKERNEL)/d_types/prod_imp.c $(KERNEL_HDR) 
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/prod_imp.c

proy_tad.o : $(DIRKERNEL)/d_types/proy_tad.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/proy_tad.c

restricc.o : $(DIRKERNEL)/d_types/restricc.c $(KERNEL_HDR) 
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/restricc.c

variacio.o : $(DIRKERNEL)/d_types/variacio.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(INCLUDE_INTERFAZ) $(DIRKERNEL)/d_types/variacio.c

ana_teo.o : $(DIRKERNEL)/d_theo/ana_teo.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_theo/ana_teo.c

man_teo.o : $(DIRKERNEL)/d_theo/man_teo.c $(KERNEL_HDR) 
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_theo/man_teo.c

sistre.o : $(DIRKERNEL)/d_theo/sistre.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_theo/sistre.c

rewrite.o : $(DIRKERNEL)/d_theo/rewrite.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_theo/rewrite.c

sustituc.o : $(DIRKERNEL)/d_theo/sustituc.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_theo/sustituc.c

tabla.o : $(DIRKERNEL)/d_theo/tabla.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_theo/tabla.c

man_prot.o : $(DIRKERNEL)/d_prot/man_prot.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_prot/man_prot.c

prototip.o : $(DIRKERNEL)/d_prot/prototip.c $(KERNEL_HDR)
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_prot/prototip.c

represen.o : $(DIRKERNEL)/d_types/represen.c $(KERNEL_HDR) 
	$(CC) $(CFLAGS) $(DIRKERNEL)/d_types/represen.c


# Application Rules

prp.o: prp.c est2abs.h
	$(CC) $(CFLAGS) $(APP_INCLUDES) prp.c

est2abs.o: est2abs.c est2abs.h
	$(CC) $(CFLAGS) $(APP_INCLUDES) est2abs.c

AbsType.o: AbsType.c AbsType.h AbsType_de.h AbsType_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) AbsType.c

Selector.o: Selector.c Selector.h Selector_de.h Selector_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Selector.c

LSelector.o: LSelector.c LSelector.h LSelector_de.h LSelector_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) LSelector.c

Constructor.o: Constructor.c Constructor.h Constructor_de.h Constructor_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Constructor.c

LConstructor.o: LConstructor.c LConstructor.h LConstructor_de.h \
	LConstructor_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) LConstructor.c

Axiom.o: Axiom.c Axiom.h Axiom_de.h Axiom_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Axiom.c

LAxiom.o: LAxiom.c LAxiom.h LAxiom_de.h LAxiom_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) LAxiom.c

Expr.o: Expr.c Expr.h Expr_de.h Expr_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Expr.c

LExpr.o: LExpr.c LExpr.h LExpr_de.h LExpr_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) LExpr.c

Domain.o: Domain.c Domain.h Domain_de.h Domain_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Domain.c

LDomain.o: LDomain.c LDomain.h LDomain_de.h LDomain_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) LDomain.c

Parameter.o: Parameter.c Parameter.h Parameter_de.h Parameter_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Parameter.c

LParameter.o: LParameter.c LParameter.h LParameter_de.h LParameter_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) LParameter.c

String.o: String.c String.h String_de.h String_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) String.c

Char.o: Char.c Char.h Char_de.h Char_co.inc
	$(CC) $(CFLAGS) $(APP_INCLUDES) Char.c










