
/**
 * Translator from ManTa 3.1 Abstract Data Types from ManTa 3.1 to AST 
 * Version: 1.0 - 1998
 * Author: Vladimir Tamara
 **/

#include "definic.h"

#include "AbsType_de.h"
#include "Axiom_de.h"
#include "Char_de.h"
#include "Generator_de.h"
#include "Domain_de.h"
#include "Expr_de.h"
#include "LAxiom_de.h"
#include "LExpr_de.h"
#include "LDomain_de.h"
#include "LGenerator_de.h"
#include "LParameter_de.h"
#include "LSelector_de.h"
#include "LString_de.h"
#include "Parameter_de.h"
#include "Selector_de.h"
#include "String_de.h"



/* Translates c strings to ManTa strings */
int chars2String(String *l,char *n);

/* Translates a nodo_nombre structure to a LString */
int nodo_nombre2LString(LString *l,nodo_nombre *n);

/* Translates a nodo_nombre structure to a LParameter */
int nodo_nombre2LParameter(LParameter *l,nodo_nombre *n);

/* Translates a nodo_dom (product of domains) to a List of Domains */
int nodo_dom2LDomain(LDomain *l,nodo_dom *n);

/* Translates a nodo_nombre (list of names) to a List of Domains */
int nodo_nombre2LDomain(LDomain *l,nodo_nombre *n);

/* Translates a nodo_argum (list of arguments of an expression) to a
   LExpr (List of Expressions) */
int nodo_argum2LExpr(LExpr *l,nodo_argum *n);

/* Translates an nodo_expression (expression) to a 
   Expr (Expressions in AST) */
int nodo_expresion2Expr(Expr *e,nodo_expresion *n);

/* Translates a nodo_igualdad (two expressions) to a 
   LAxiom (List of Axioms) */
int nodo_igualdad2LAxiom(LAxiom *l,nodo_igualdad *n);

/* Translates a nodo_select (list of selectors) to a 
   LSelector (List of Selectors in AST) */
int nodo_select2LSelector(LSelector *l,nodo_select *n);

/* Translates a nodo_generadora (list of constructors or initials) to a 
   LGenerator (List of Generators) */
int nodo_generadora2LGenerator(char *, LGenerator *,nodo_generadora *);

/* Translates a nodo_tad (TAD) to an AbsType (AST of an ADT) */
int nodo_tad2AbsType(AbsType *ty,nodo_tad *t);


